diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/source/window/salframeview.mm ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/window/salframeview.mm
--- ooo_SRC680_m233_src.orig/vcl/aqua/source/window/salframeview.mm	1970-01-01 01:00:00.000000000 +0100
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/window/salframeview.mm	2007-10-23 16:23:37.000000000 +0200
@@ -0,0 +1,778 @@
+/*n***********************************************************************
+ *
+ *  OpenOffice.org - a multi-platform office productivity suite
+ *
+ *  $RCSfile$
+ *
+ *  $Revision$
+ *
+ *  last change: $Author$ $Date$
+ *
+ *  The Contents of this file are made available subject to
+ *  the terms of GNU Lesser General Public License Version 2.1.
+ *
+ *
+ *    GNU Lesser General Public License Version 2.1
+ *    =============================================
+ *    Copyright 2005 by Sun Microsystems, Inc.
+ *    901 San Antonio Road, Palo Alto, CA 94303, USA
+ *
+ *    This library is free software; you can redistribute it and/or
+ *    modify it under the terms of the GNU Lesser General Public
+ *    License version 2.1, as published by the Free Software Foundation.
+ *
+ *    This library is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ *    Lesser General Public License for more details.
+ *
+ *    You should have received a copy of the GNU Lesser General Public
+ *    License along with this library; if not, write to the Free Software
+ *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ *    MA  02111-1307  USA
+ *
+ ************************************************************************/
+
+// MARKER(update_precomp.py): autogen include statement, do not remove
+#include "precompiled_vcl.hxx"
+
+#include "salinst.h"
+#include "salgdi.h"
+#include "salframe.h"
+#include "salframeview.h"
+ 
+static USHORT ImplGetModifierMask( unsigned int nMask, bool bKeyEvent )
+{
+    USHORT nRet = 0;
+    if( (nMask & NSShiftKeyMask) != 0 )
+        nRet |= KEY_SHIFT;
+    if( (nMask & NSControlKeyMask) != 0 )
+        nRet |= KEY_MOD1;
+    if( (nMask & NSAlternateKeyMask) != 0 )
+        nRet |= bKeyEvent ? KEY_MOD3 : KEY_MOD2;
+    if( (nMask & NSCommandKeyMask) != 0 )
+        nRet |= KEY_MOD3;
+    return nRet;
+}
+
+static USHORT ImplMapCharCode( sal_Unicode aCode )
+{
+    static USHORT aKeyCodeMap[ 128 ] =
+    {
+        0, 0, 0, 0, 0, 0, 0, 0,
+        KEY_BACKSPACE, KEY_TAB, KEY_RETURN, 0, 0, KEY_RETURN, 0, 0,
+        0, 0, 0, 0, 0, 0, 0, 0,
+        0, 0, 0, KEY_ESCAPE, 0, 0, 0, 0,
+        KEY_SPACE, 0, 0, 0, 0, 0, 0, 0,
+        0, 0, KEY_MULTIPLY, KEY_ADD, KEY_COMMA, KEY_SUBTRACT, KEY_POINT, KEY_DIVIDE,
+        KEY_0, KEY_1, KEY_2, KEY_3, KEY_4, KEY_5, KEY_6, KEY_7,
+        KEY_8, KEY_9, 0, 0, KEY_LESS, KEY_EQUAL, KEY_GREATER, 0,
+        0, KEY_A, KEY_B, KEY_C, KEY_D, KEY_E, KEY_F, KEY_G,
+        KEY_H, KEY_I, KEY_J, KEY_K, KEY_L, KEY_M, KEY_N, KEY_O,
+        KEY_P, KEY_Q, KEY_R, KEY_S, KEY_T, KEY_U, KEY_V, KEY_W,
+        KEY_X, KEY_Y, KEY_Z, 0, 0, 0, 0, 0,
+        KEY_QUOTELEFT, KEY_A, KEY_B, KEY_C, KEY_D, KEY_E, KEY_F, KEY_G,
+        KEY_H, KEY_I, KEY_J, KEY_K, KEY_L, KEY_M, KEY_N, KEY_O,
+        KEY_P, KEY_Q, KEY_R, KEY_S, KEY_T, KEY_U, KEY_V, KEY_W,
+        KEY_X, KEY_Y, KEY_Z, 0, 0, 0, KEY_TILDE, KEY_DELETE
+    };
+    
+    static USHORT aFunctionKeyCodeMap[ 128 ] =
+    {
+        KEY_UP, KEY_DOWN, KEY_LEFT, KEY_RIGHT, KEY_F1, KEY_F2, KEY_F3, KEY_F4,
+        KEY_F5, KEY_F6, KEY_F7, KEY_F8, KEY_F9, KEY_F10, KEY_F11, KEY_F12,
+        KEY_F13, KEY_F14, KEY_F15, KEY_F16, KEY_F17, KEY_F18, KEY_F19, KEY_F20,
+        KEY_F21, KEY_F22, KEY_F23, KEY_F24, KEY_F25, KEY_F26, 0, 0,
+        0, 0, 0, 0, 0, 0, 0, KEY_INSERT,
+        KEY_DELETE, KEY_HOME, 0, KEY_END, KEY_PAGEUP, KEY_PAGEDOWN, 0, 0,
+        0, 0, 0, 0, 0, KEY_MENU, 0, 0,
+        0, 0, 0, 0, 0, 0, 0, 0,
+        0, 0, 0, KEY_UNDO, KEY_REPEAT, KEY_FIND, KEY_HELP, 0,
+        0, 0, 0, 0, 0, 0, 0, 0,
+        0, 0, 0, 0, 0, 0, 0, 0,
+        0, 0, 0, 0, 0, 0, 0, 0,
+        0, 0, 0, 0, 0, 0, 0, 0,
+        0, 0, 0, 0, 0, 0, 0, 0,
+        0, 0, 0, 0, 0, 0, 0, 0,
+        0, 0, 0, 0, 0, 0, 0, 0
+    };
+    
+    USHORT nKeyCode = 0;
+    if( aCode < sizeof( aKeyCodeMap) / sizeof( aKeyCodeMap[0] ) )
+        nKeyCode = aKeyCodeMap[ aCode ];
+    else if( aCode >= 0xf700 && aCode < 0xf780 )
+        nKeyCode = aFunctionKeyCodeMap[ aCode - 0xf700 ]; 
+    return nKeyCode;
+}
+
+static AquaSalFrame* pMouseFrame = NULL;
+
+@implementation SalFrameWindow
+-(id)initWithSalFrame: (AquaSalFrame*)pFrame
+{
+    mpFrame = pFrame;
+    NSRect aRect = { { pFrame->maGeometry.nX, pFrame->maGeometry.nY },
+                     { pFrame->maGeometry.nWidth, pFrame->maGeometry.nHeight } };
+    pFrame->VCLToCocoa( aRect );
+    return [super initWithContentRect: aRect styleMask: mpFrame->getStyleMask() backing: NSBackingStoreBuffered defer: NO ];
+}
+
+-(AquaSalFrame*)getSalFrame
+{
+    return mpFrame;
+}
+
+-(void)windowDidBecomeKey: (NSNotification*)pNotification
+{
+    YIELD_GUARD;
+
+    if( mpFrame && AquaSalFrame::isAlive( mpFrame ) )
+    {
+        if( mpFrame->mpMenu )
+            mpFrame->mpMenu->setMainMenu();
+        #if 0
+        // FIXME: we should disable menus while in modal mode
+        // however from down here there is currently no reliable way to
+        // find out when to do this
+        if( (mpFrame->mpParent && mpFrame->mpParent->GetWindow()->IsInModalMode()) )
+            AquaSalMenu::enableMainMenu( false );
+        #endif
+        mpFrame->CallCallback( SALEVENT_GETFOCUS, 0 );
+    }
+}
+
+-(void)windowDidResignKey: (NSNotification*)pNotification
+{
+    YIELD_GUARD;
+
+    if( mpFrame && AquaSalFrame::isAlive( mpFrame ) )
+        mpFrame->CallCallback(SALEVENT_LOSEFOCUS, 0);
+}
+
+-(void)windowDidChangeScreen: (NSNotification*)pNotification
+{
+    // FIXME: multiscreen
+}
+
+-(void)windowDidMove: (NSNotification*)pNotification
+{
+    YIELD_GUARD;
+
+    if( mpFrame && AquaSalFrame::isAlive( mpFrame ) )
+    {
+        mpFrame->UpdateFrameGeometry();
+        mpFrame->CallCallback( SALEVENT_MOVE, 0 );
+    }
+}
+
+-(void)windowDidResize: (NSNotification*)pNotification
+{
+    YIELD_GUARD;
+
+    if( mpFrame && AquaSalFrame::isAlive( mpFrame ) )
+    {
+        mpFrame->UpdateFrameGeometry();
+        mpFrame->CallCallback( SALEVENT_RESIZE, 0 );
+    }
+}
+
+-(void)windowDidMiniaturize: (NSNotification*)pNotification
+{
+    YIELD_GUARD;
+
+    if( mpFrame && AquaSalFrame::isAlive( mpFrame ) )
+    {
+        mpFrame->mbShown = false;
+        mpFrame->UpdateFrameGeometry();
+        mpFrame->CallCallback( SALEVENT_RESIZE, 0 );
+    }
+}
+
+-(void)windowDidDeminiaturize: (NSNotification*)pNotification
+{
+    YIELD_GUARD;
+
+    if( mpFrame && AquaSalFrame::isAlive( mpFrame ) )
+    {
+        mpFrame->mbShown = true;
+        mpFrame->UpdateFrameGeometry();
+        mpFrame->CallCallback( SALEVENT_RESIZE, 0 );
+    }
+}
+
+-(MacOSBOOL)windowShouldClose: (NSNotification*)pNotification
+{
+    YIELD_GUARD;
+
+    MacOSBOOL bRet = YES;
+    if( mpFrame && AquaSalFrame::isAlive( mpFrame ) )
+    {
+        mpFrame->CallCallback( SALEVENT_CLOSE, 0 );
+        bRet = NO; // application will close the window or not, AppKit shouldn't
+    }
+    return bRet;
+}
+
+-(void)dockMenuItemTriggered: (id)sender
+{
+    YIELD_GUARD;
+
+    if( mpFrame && AquaSalFrame::isAlive( mpFrame ) )
+        mpFrame->ToTop( SAL_FRAME_TOTOP_RESTOREWHENMIN | SAL_FRAME_TOTOP_GRABFOCUS );
+}
+
+@end
+
+@implementation SalFrameView
++(void)unsetMouseFrame: (AquaSalFrame*)pFrame
+{
+    if( pFrame == pMouseFrame )
+        pMouseFrame = NULL;
+}
+
+-(id)initWithSalFrame: (AquaSalFrame*)pFrame
+{
+    mpFrame = pFrame;
+    if ((self = [super initWithFrame: [NSWindow contentRectForFrameRect: [mpFrame->getWindow() frame] styleMask: mpFrame->mnStyleMask]]) != nil)
+    {
+        mMarkedRange = NSMakeRange(NSNotFound, 0);
+        mSelectedRange = NSMakeRange(NSNotFound, 0);
+    }
+
+    return self;
+}
+
+-(void)resetCursorRects
+{
+    if( mpFrame && AquaSalFrame::isAlive( mpFrame ) )
+    {
+        // FIXME: does this leak the returned NSCursor of getCurrentCursor ?
+        NSRect aRect = { { 0, 0 }, { mpFrame->maGeometry.nWidth, mpFrame->maGeometry.nHeight } };
+        [self addCursorRect: aRect cursor: mpFrame->getCurrentCursor()];
+    }
+}
+
+-(MacOSBOOL)acceptsFirstResponder
+{
+    return YES;
+}
+
+-(MacOSBOOL)acceptsFirstMouse: (NSEvent*)pEvent
+{
+    return YES;
+}
+
+-(MacOSBOOL)isOpaque
+{
+    return YES;
+}
+
+-(void)drawRect: (NSRect)aRect
+{
+    AquaLog( "drawRect\n" );
+
+    YIELD_GUARD;
+
+    if( mpFrame && AquaSalFrame::isAlive( mpFrame ) )
+    {
+        // FIXME: optimize UpdateWindow wrt to aRect
+        if( mpFrame->mpGraphics )
+            mpFrame->mpGraphics->UpdateWindow( [NSGraphicsContext currentContext] );
+    }
+}
+
+-(void)sendMouseEventToFrame: (NSEvent*)pEvent button:(USHORT)nButton eventtype:(USHORT)nEvent
+{
+    YIELD_GUARD;
+
+    AquaSalFrame* pDispatchFrame = AquaSalFrame::GetCaptureFrame();
+    if( pDispatchFrame )
+    {
+        if( nEvent == SALEVENT_MOUSELEAVE ) // no leave events if mouse is captured
+            nEvent = SALEVENT_MOUSEMOVE;
+    }
+    else if( pMouseFrame )
+        pDispatchFrame = pMouseFrame;
+    else
+        pDispatchFrame = mpFrame;
+    
+    
+    if( pDispatchFrame && AquaSalFrame::isAlive( pDispatchFrame ) )
+    {
+        pDispatchFrame->mnLastEventTime = static_cast<ULONG>( [pEvent timestamp] * 1000.0 );
+        pDispatchFrame->mnLastModifierFlags = [pEvent modifierFlags];
+
+        NSPoint aPt = [NSEvent mouseLocation];
+        pDispatchFrame->CocoaToVCL( aPt );
+        
+        USHORT nModMask = ImplGetModifierMask( [pEvent modifierFlags], false );
+        // #i82284# emulate ctrl left
+        if( nModMask == KEY_MOD1 && nButton == MOUSE_LEFT )
+        {
+            nModMask    = 0;
+            nButton     = MOUSE_RIGHT;
+        }
+
+        SalMouseEvent aEvent;
+        aEvent.mnTime   = pDispatchFrame->mnLastEventTime;
+        aEvent.mnX      = static_cast<long>(aPt.x) - pDispatchFrame->maGeometry.nX;
+        aEvent.mnY      = static_cast<long>(aPt.y) - pDispatchFrame->maGeometry.nY;
+        aEvent.mnButton = nButton;
+        aEvent.mnCode   =  aEvent.mnButton | nModMask;
+     
+        pDispatchFrame->CallCallback( nEvent, &aEvent );
+    }
+}
+
+-(void)mouseDown: (NSEvent*)pEvent
+{
+    [self sendMouseEventToFrame:pEvent button:MOUSE_LEFT eventtype:SALEVENT_MOUSEBUTTONDOWN];
+}
+
+-(void)mouseDragged: (NSEvent*)pEvent
+{
+    [self sendMouseEventToFrame:pEvent button:MOUSE_LEFT eventtype:SALEVENT_MOUSEMOVE];
+}
+
+-(void)mouseUp: (NSEvent*)pEvent
+{
+    [self sendMouseEventToFrame:pEvent button:MOUSE_LEFT eventtype:SALEVENT_MOUSEBUTTONUP];
+}
+
+-(void)mouseMoved: (NSEvent*)pEvent
+{
+    [self sendMouseEventToFrame:pEvent button:0 eventtype:SALEVENT_MOUSEMOVE];
+}
+
+-(void)mouseEntered: (NSEvent*)pEvent
+{
+    pMouseFrame = mpFrame;
+    
+    [self sendMouseEventToFrame:pEvent button:0 eventtype:SALEVENT_MOUSEMOVE];
+}
+
+-(void)mouseExited: (NSEvent*)pEvent
+{
+    if( pMouseFrame == mpFrame )
+        pMouseFrame = NULL;
+
+    [self sendMouseEventToFrame:pEvent button:0 eventtype:SALEVENT_MOUSELEAVE];
+}
+
+-(void)rightMouseDown: (NSEvent*)pEvent
+{
+    [self sendMouseEventToFrame:pEvent button:MOUSE_RIGHT eventtype:SALEVENT_MOUSEBUTTONDOWN];
+}
+
+-(void)rightMouseDragged: (NSEvent*)pEvent
+{
+    [self sendMouseEventToFrame:pEvent button:MOUSE_RIGHT eventtype:SALEVENT_MOUSEMOVE];
+}
+
+-(void)rightMouseUp: (NSEvent*)pEvent
+{
+    [self sendMouseEventToFrame:pEvent button:MOUSE_RIGHT eventtype:SALEVENT_MOUSEBUTTONUP];
+}
+
+-(void)otherMouseDown: (NSEvent*)pEvent
+{
+    if( [pEvent buttonNumber] == 2 )
+        [self sendMouseEventToFrame:pEvent button:MOUSE_MIDDLE eventtype:SALEVENT_MOUSEBUTTONDOWN];
+}
+
+-(void)otherMouseDragged: (NSEvent*)pEvent
+{
+    if( [pEvent buttonNumber] == 2 )
+        [self sendMouseEventToFrame:pEvent button:MOUSE_MIDDLE eventtype:SALEVENT_MOUSEMOVE];
+}
+
+-(void)otherMouseUp: (NSEvent*)pEvent
+{
+    if( [pEvent buttonNumber] == 2 )
+        [self sendMouseEventToFrame:pEvent button:MOUSE_MIDDLE eventtype:SALEVENT_MOUSEBUTTONUP];
+}
+
+-(void)scrollWheel: (NSEvent*)pEvent
+{
+    YIELD_GUARD;
+    
+    if( AquaSalFrame::isAlive( mpFrame ) )
+    {
+        mpFrame->mnLastEventTime = static_cast<ULONG>( [pEvent timestamp] * 1000.0 );
+        mpFrame->mnLastModifierFlags = [pEvent modifierFlags];
+
+        NSPoint aPt = [NSEvent mouseLocation];
+        mpFrame->CocoaToVCL( aPt );
+
+        SalWheelMouseEvent aEvent;
+        aEvent.mnTime   = mpFrame->mnLastEventTime;
+        aEvent.mnX      = static_cast<long>(aPt.x) - mpFrame->maGeometry.nX;
+        aEvent.mnY      = static_cast<long>(aPt.y) - mpFrame->maGeometry.nY;
+        aEvent.mnCode   = ImplGetModifierMask( mpFrame->mnLastModifierFlags, false ); // FIXME: button code
+        aEvent.mnScrollLines = SAL_WHEELMOUSE_EVENT_PAGESCROLL;
+
+        float dX = [pEvent deltaX];
+        float dY = [pEvent deltaY];
+        if( dX != 0.0 )
+        {
+            aEvent.mnDelta = static_cast<long>(floor(dX));
+            aEvent.mnNotchDelta = aEvent.mnDelta;
+            aEvent.mbHorz = TRUE;
+            mpFrame->CallCallback( SALEVENT_WHEELMOUSE, &aEvent );
+        }
+        if( dY != 0.0 && AquaSalFrame::isAlive( mpFrame ) )
+        {
+            aEvent.mnDelta = static_cast<long>(floor(dY));
+            aEvent.mnNotchDelta = aEvent.mnDelta;
+            aEvent.mbHorz = FALSE;
+            mpFrame->CallCallback( SALEVENT_WHEELMOUSE, &aEvent );
+        }
+    }
+}
+
+-(void)keyDown: (NSEvent*)pEvent
+{
+    YIELD_GUARD;
+    
+    if( AquaSalFrame::isAlive( mpFrame ) )
+    {
+        mpLastEvent = pEvent;
+        mbInKeyInput = true;
+        mbNeedSpecialKeyHandle = false;
+        mbKeyHandled = false;
+
+        mpFrame->mnLastEventTime = static_cast<ULONG>( [pEvent timestamp] * 1000.0 );
+        mpFrame->mnLastModifierFlags = [pEvent modifierFlags];
+
+        bool bHandleCommandKey = mpFrame->mpMenu ? false : true;
+        if( (mpFrame->mnLastModifierFlags & NSControlKeyMask) ||
+            ( (mpFrame->mnLastModifierFlags & NSCommandKeyMask) && bHandleCommandKey )
+            )
+        {
+            // note: checkSpecialCharacters sets mbInKeyInput to false as a side effect
+            //       if the event is consumed
+            if ( [self checkSpecialCharacters:pEvent] )
+                return;
+        }
+
+        NSArray* pArray = [NSArray arrayWithObject: pEvent];
+        [self interpretKeyEvents: pArray];
+
+        mbInKeyInput = false;
+    }
+}
+
+-(void)flagsChanged: (NSEvent*)pEvent
+{
+    YIELD_GUARD;
+    
+    if( AquaSalFrame::isAlive( mpFrame ) )
+    {
+        mpFrame->mnLastEventTime = static_cast<ULONG>( [pEvent timestamp] * 1000.0 );
+        mpFrame->mnLastModifierFlags = [pEvent modifierFlags];
+    }
+}
+
+-(void)insertText:(id)aString
+{
+    YIELD_GUARD;
+    
+    if( AquaSalFrame::isAlive( mpFrame ) )
+    {
+        NSString* pInsert = nil;
+        if( [aString isMemberOfClass: [NSAttributedString class]] )
+            pInsert = [aString string];
+        else
+            pInsert = aString;
+        
+        int nLen = 0;
+        if( pInsert && ( nLen = [pInsert length] ) > 0 )
+        {
+            OUString aInsertString( GetOUString( pInsert ) );
+            USHORT nKeyCode = 0;
+             // aCharCode initializer is safe since aInsertString will at least contain '\0'
+            sal_Unicode aCharCode = *aInsertString.getStr();
+            // FIXME: will probably break somehow in less than trivial text input mode
+            if( nLen == 1 &&
+                aCharCode < 0x80 &&
+                aCharCode > 0x1f &&
+                ( nKeyCode = ImplMapCharCode( aCharCode ) ) != 0
+                )
+            {
+                [self sendKeyInputAndReleaseToFrame: nKeyCode character: aCharCode];
+            }
+            else
+            {
+                SalExtTextInputEvent aEvent;
+                aEvent.mnTime           = mpFrame->mnLastEventTime;
+                aEvent.maText           = aInsertString;
+                aEvent.mpTextAttr       = NULL;
+                aEvent.mnCursorPos      = aInsertString.getLength();
+                aEvent.mnDeltaStart     = 0;
+                aEvent.mnCursorFlags    = 0;
+                aEvent.mbOnlyCursor     = FALSE;
+                mpFrame->CallCallback( SALEVENT_EXTTEXTINPUT, &aEvent );
+                if( AquaSalFrame::isAlive( mpFrame ) )
+                    mpFrame->CallCallback( SALEVENT_ENDEXTTEXTINPUT, 0 );
+            }
+        }
+        else
+        {
+            SalExtTextInputEvent aEvent;
+            aEvent.mnTime           = mpFrame->mnLastEventTime;
+            aEvent.maText           = String();
+            aEvent.mpTextAttr       = NULL;
+            aEvent.mnCursorPos      = 0;
+            aEvent.mnDeltaStart     = 0;
+            aEvent.mnCursorFlags    = 0;
+            aEvent.mbOnlyCursor     = FALSE;
+            mpFrame->CallCallback( SALEVENT_EXTTEXTINPUT, &aEvent );
+            if( AquaSalFrame::isAlive( mpFrame ) )
+                mpFrame->CallCallback( SALEVENT_ENDEXTTEXTINPUT, 0 );
+
+        }
+        mbKeyHandled = true;
+    }
+}
+
+-(void)insertTab: (id)aSender
+{
+    [self sendKeyInputAndReleaseToFrame: KEY_TAB character: '\t'];
+}
+
+-(void)moveLeft: (id)aSender
+{
+    [self sendKeyInputAndReleaseToFrame: KEY_LEFT character: 0];
+}
+
+-(void)moveRight: (id)aSender
+{
+    [self sendKeyInputAndReleaseToFrame: KEY_RIGHT character: 0];
+}
+
+-(void)moveUp: (id)aSender
+{
+    [self sendKeyInputAndReleaseToFrame: KEY_UP character: 0];
+}
+
+-(void)moveDown: (id)aSender
+{
+    [self sendKeyInputAndReleaseToFrame: KEY_DOWN character: 0];
+}
+
+-(void)insertNewline: (id)aSender
+{
+    [self sendKeyInputAndReleaseToFrame: KEY_RETURN character: '\n'];
+}
+
+-(void)deleteBackward: (id)aSender
+{
+    [self sendKeyInputAndReleaseToFrame: KEY_BACKSPACE character: '\b'];
+}
+
+-(void)deleteForward: (id)aSender
+{
+    [self sendKeyInputAndReleaseToFrame: KEY_DELETE character: 0x7f];
+}
+
+-(void)cancelOperation: (id)aSender
+{
+    [self sendKeyInputAndReleaseToFrame: KEY_ESCAPE character: 0x1b];
+}
+
+-(void)sendKeyInputAndReleaseToFrame: (USHORT)nKeyCode  character: (sal_Unicode)aChar
+{
+    YIELD_GUARD;
+    
+    if( AquaSalFrame::isAlive( mpFrame ) )
+    {
+        SalKeyEvent aEvent;
+        aEvent.mnTime           = mpFrame->mnLastEventTime;
+        aEvent.mnCode           = nKeyCode | ImplGetModifierMask( mpFrame->mnLastModifierFlags, true );
+        aEvent.mnCharCode       = aChar;
+        aEvent.mnRepeat         = FALSE;
+        mpFrame->CallCallback( SALEVENT_KEYINPUT, &aEvent );
+        if( AquaSalFrame::isAlive( mpFrame ) )
+            mpFrame->CallCallback( SALEVENT_KEYUP, &aEvent );
+    }
+}
+
+
+-(MacOSBOOL)checkSpecialCharacters: (NSEvent *)pEvent
+{
+    // check for special characters
+    NSString* pUnmodifiedString = [pEvent charactersIgnoringModifiers]; 
+
+    if( pUnmodifiedString && [pUnmodifiedString length] == 1 )
+    {
+        unichar keyChar = [pUnmodifiedString characterAtIndex: 0];
+        USHORT nKeyCode = ImplMapCharCode( keyChar );
+        bool bUseKeyInput = false;
+        if( nKeyCode != 0 )
+        {
+            // handle function keys, let unmodified cursor keys through to input manager
+            if( keyChar >= 0xf704 && keyChar < 0xf900 )
+                bUseKeyInput = true;
+            else if( keyChar >= 0xf700 && keyChar < 0xf704 &&
+                    mpFrame->mnLastModifierFlags != 0 )
+                bUseKeyInput = true;
+            else if( ((mpFrame->mnLastModifierFlags & ~(NSControlKeyMask | NSAlternateKeyMask | NSShiftKeyMask)) &  NSDeviceIndependentModifierFlagsMask) == 0 &&
+                    (mpFrame->mnLastModifierFlags & (NSControlKeyMask | NSAlternateKeyMask)) != 0 )
+                bUseKeyInput = true;
+            else if( (mpFrame->mnLastModifierFlags & NSCommandKeyMask) && mpFrame->mpMenu == NULL )
+                bUseKeyInput = true;
+        }
+        if( bUseKeyInput )
+        {
+            [self sendKeyInputAndReleaseToFrame: nKeyCode character: 0];
+            mbInKeyInput = false;
+
+            return TRUE;
+        }
+    }
+    return FALSE;
+}
+
+
+// NSTextInput protocol
+- (NSArray *)validAttributesForMarkedText
+{
+    // FIXME
+    return [NSArray array];
+}
+
+- (MacOSBOOL)hasMarkedText
+{
+    MacOSBOOL bHasMarkedText;
+
+    bHasMarkedText = ( mMarkedRange.location != NSNotFound ) &&
+                     ( mMarkedRange.length != 0 );
+    // hack to check keys like "Control-j"
+    if( mbInKeyInput )
+    {
+        mbNeedSpecialKeyHandle = true;
+    }
+    return bHasMarkedText;
+}
+
+- (NSRange)markedRange
+{
+    return [self hasMarkedText] ? mMarkedRange : NSMakeRange( NSNotFound, 0 );
+}
+
+- (NSRange)selectedRange
+{
+    return mSelectedRange;
+}
+
+- (void)setMarkedText:(id)aString selectedRange:(NSRange)selRange
+{
+    AquaLog( ">*>_> %s\n",__func__ );
+    AquaLog( "location: %d, length: %d\n", selRange.location, selRange.length );
+    AquaLog( "aString = '%@'\n", aString );
+    AquaLog( "length %d\n", [aString length] );
+
+    if( ![aString isKindOfClass:[NSAttributedString class]] )
+        aString = [[[NSAttributedString alloc] initWithString:aString] autorelease];
+    NSRange rangeToReplace = [self hasMarkedText] ? [self markedRange] : [self selectedRange];
+    mMarkedRange = NSMakeRange( rangeToReplace.location, [aString length] );
+    mSelectedRange = NSMakeRange( rangeToReplace.location + selRange.location, selRange.length );
+
+    int len = [aString length];
+    SalExtTextInputEvent aInputEvent;
+    aInputEvent.mnTime = mpFrame->mnLastEventTime;
+    aInputEvent.mnDeltaStart = 0;
+    aInputEvent.mbOnlyCursor = FALSE;
+    if( len > 0 ) {
+        NSString *pString = [aString string];
+        OUString aInsertString( GetOUString( pString ) );
+        std::vector<USHORT> aInputFlags = std::vector<USHORT>( std::max( 1, len ), 0 );
+        for ( int i = 0; i < len; i++ )
+        {
+            // FIXME
+            aInputFlags[i] = SAL_EXTTEXTINPUT_ATTR_UNDERLINE;
+        }
+
+        aInputEvent.maText = aInsertString;
+        aInputEvent.mnCursorPos = selRange.location;
+        aInputEvent.mpTextAttr = &aInputFlags[0];
+        mpFrame->CallCallback( SALEVENT_EXTTEXTINPUT, (void *)&aInputEvent );
+    } else {
+        aInputEvent.maText = String();
+        aInputEvent.mnCursorPos = 0;
+        aInputEvent.mnCursorFlags = 0;
+        aInputEvent.mpTextAttr = 0;
+        mpFrame->CallCallback( SALEVENT_EXTTEXTINPUT, (void *)&aInputEvent );
+        mpFrame->CallCallback( SALEVENT_ENDEXTTEXTINPUT, 0 );
+    }
+    mbKeyHandled= true;
+}
+
+- (void)unmarkText
+{
+    AquaLog( ">*>_> %s\n", __func__ );
+
+    mSelectedRange = mMarkedRange = NSMakeRange(NSNotFound, 0);
+}
+
+- (NSAttributedString *)attributedSubstringFromRange:(NSRange)theRange
+{
+    AquaLog( ">*>_> %s\n", __func__ );
+    AquaLog( "theRange = %d, %d\n", theRange.location, theRange.length);
+
+    // FIXME
+    return nil;
+}
+
+- (unsigned int)characterIndexForPoint:(NSPoint)thePoint
+{
+    AquaLog( ">*>_> %s\n",__func__ );
+
+    // FIXME
+    return 0;
+}
+
+- (long)conversationIdentifier
+{
+    return (long)self;
+}
+
+- (void)doCommandBySelector:(SEL)aSelector
+{
+    AquaLog( ">*>_> %s\n",__func__ );
+    AquaLog( "aSelector %s", aSelector );
+
+    // check for special characters with OOo way
+    if ( [self checkSpecialCharacters:mpLastEvent] )
+    {
+        mbKeyHandled = true;
+        return;
+    }
+
+    // Cocoa way
+    (void)[self performSelector: aSelector];
+    mbKeyHandled = true;
+}
+
+- (NSRect)firstRectForCharacterRange:(NSRange)theRange
+{
+    AquaLog( ">*>_> %s\n",__func__ );
+    AquaLog( "mSelectedRange = %d, %d", mSelectedRange.location, mSelectedRange.length );
+    AquaLog( " theRange = %d, %d\n", theRange.location, theRange.length );
+
+    SalExtTextInputPosEvent aPosEvent;
+    mpFrame->CallCallback( SALEVENT_EXTTEXTINPUTPOS, (void *)&aPosEvent );
+
+    NSRect rect;
+
+    rect.origin.x = aPosEvent.mnX + mpFrame->maGeometry.nX;
+    rect.origin.y =   aPosEvent.mnY + mpFrame->maGeometry.nY + 4; // add some space for underlines
+    rect.size.width = aPosEvent.mnWidth;
+    rect.size.height = aPosEvent.mnHeight;
+
+    mpFrame->VCLToCocoa( rect );
+    return rect;
+}
+
+@end
+
diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/source/window/salmenu.cxx ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/window/salmenu.cxx
--- ooo_SRC680_m233_src.orig/vcl/aqua/source/window/salmenu.cxx	2007-10-09 17:17:04.000000000 +0200
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/window/salmenu.cxx	2007-10-15 15:24:26.000000000 +0200
@@ -36,6 +36,7 @@
 #include "saldata.hxx"
 #include "salinst.h"
 #include "salmenu.h"
+#include "salnsmenu.h"
 #include "salframe.h"
 #include "vcl/svids.hrc"
 #include "vcl/cmdevt.hxx"
@@ -555,63 +556,3 @@
 
 // -------------------------------------------------------------------
 
-@implementation SalNSMenu
--(id)initWithMenu: (AquaSalMenu*)pMenu
-{
-    mpMenu = pMenu;
-    return [super initWithTitle: [NSString string]];
-}
-
--(void)menuNeedsUpdate: (NSMenu*)pMenu
-{
-    YIELD_GUARD;
-    
-    if( mpMenu )
-    {
-        const AquaSalFrame* pFrame = mpMenu->getFrame();
-        if( pFrame && AquaSalFrame::isAlive( pFrame ) )
-        {
-            SalMenuEvent aMenuEvt;
-            aMenuEvt.mnId   = 0;
-            aMenuEvt.mpMenu = mpMenu->mpVCLMenu;
-            if( aMenuEvt.mpMenu )
-            {
-                pFrame->CallCallback(SALEVENT_MENUACTIVATE, &aMenuEvt);
-                pFrame->CallCallback(SALEVENT_MENUDEACTIVATE, &aMenuEvt);
-            }
-            else
-                DBG_ERROR( "unconnected menu" );
-        }
-    }
-}
-
--(void)setSalMenu: (AquaSalMenu*)pMenu
-{
-    mpMenu = pMenu;
-}
-@end
-
-@implementation SalNSMenuItem
--(id)initWithMenuItem: (AquaSalMenuItem*)pMenuItem
-{
-    mpMenuItem = pMenuItem;
-    id ret = [super initWithTitle: [NSString string] action: nil keyEquivalent: [NSString string]];
-    [ret setAction:@selector(menuItemTriggered:)];
-    [ret setTarget: self];
-    return ret;
-}
--(void)menuItemTriggered: (id)aSender
-{
-    YIELD_GUARD;
-    
-    const AquaSalFrame* pFrame = mpMenuItem->mpParentMenu ? mpMenuItem->mpParentMenu->getFrame() : NULL;
-    if( pFrame && AquaSalFrame::isAlive( pFrame ) && ! pFrame->GetWindow()->IsInModalMode() )
-    {
-        SalMenuEvent aMenuEvt;
-        aMenuEvt.mnId   = mpMenuItem->mnId;
-        aMenuEvt.mpMenu = mpMenuItem->mpVCLMenu;
-        pFrame->CallCallback(SALEVENT_MENUCOMMAND, &aMenuEvt);
-    }
-}
-@end
-
diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/source/window/salnsmenu.mm ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/window/salnsmenu.mm
--- ooo_SRC680_m233_src.orig/vcl/aqua/source/window/salnsmenu.mm	1970-01-01 01:00:00.000000000 +0100
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/window/salnsmenu.mm	2007-10-15 15:24:26.000000000 +0200
@@ -0,0 +1,106 @@
+/*************************************************************************
+ *
+ *  OpenOffice.org - a multi-platform office productivity suite
+ *
+ *  $RCSfile$
+ *
+ *  $Revision$
+ *
+ *  last change: $Author$ $Date$
+ *
+ *  The Contents of this file are made available subject to
+ *  the terms of GNU Lesser General Public License Version 2.1.
+ *
+ *
+ *    GNU Lesser General Public License Version 2.1
+ *    =============================================
+ *    Copyright 2005 by Sun Microsystems, Inc.
+ *    901 San Antonio Road, Palo Alto, CA 94303, USA
+ *
+ *    This library is free software; you can redistribute it and/or
+ *    modify it under the terms of the GNU Lesser General Public
+ *    License version 2.1, as published by the Free Software Foundation.
+ *
+ *    This library is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ *    Lesser General Public License for more details.
+ *
+ *    You should have received a copy of the GNU Lesser General Public
+ *    License along with this library; if not, write to the Free Software
+ *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ *    MA  02111-1307  USA
+ *
+ ************************************************************************/
+
+// MARKER(update_precomp.py): autogen include statement, do not remove
+#include "precompiled_vcl.hxx"
+
+#include "salinst.h"
+#include "saldata.hxx"
+#include "salframe.h"
+#include "salmenu.h"
+#include "salnsmenu.h"
+
+#include "vcl/window.hxx"
+ 
+@implementation SalNSMenu
+-(id)initWithMenu: (AquaSalMenu*)pMenu
+{
+    mpMenu = pMenu;
+    return [super initWithTitle: [NSString string]];
+}
+
+-(void)menuNeedsUpdate: (NSMenu*)pMenu
+{
+    YIELD_GUARD;
+    
+    if( mpMenu )
+    {
+        const AquaSalFrame* pFrame = mpMenu->getFrame();
+        if( pFrame && AquaSalFrame::isAlive( pFrame ) )
+        {
+            SalMenuEvent aMenuEvt;
+            aMenuEvt.mnId   = 0;
+            aMenuEvt.mpMenu = mpMenu->mpVCLMenu;
+            if( aMenuEvt.mpMenu )
+            {
+                pFrame->CallCallback(SALEVENT_MENUACTIVATE, &aMenuEvt);
+                pFrame->CallCallback(SALEVENT_MENUDEACTIVATE, &aMenuEvt);
+            }
+            else
+                DBG_ERROR( "unconnected menu" );
+        }
+    }
+}
+
+-(void)setSalMenu: (AquaSalMenu*)pMenu
+{
+    mpMenu = pMenu;
+}
+@end
+
+@implementation SalNSMenuItem
+-(id)initWithMenuItem: (AquaSalMenuItem*)pMenuItem
+{
+    mpMenuItem = pMenuItem;
+    id ret = [super initWithTitle: [NSString string] action: nil keyEquivalent: [NSString string]];
+    [ret setAction:@selector(menuItemTriggered:)];
+    [ret setTarget: self];
+    return ret;
+}
+-(void)menuItemTriggered: (id)aSender
+{
+    YIELD_GUARD;
+    
+    const AquaSalFrame* pFrame = mpMenuItem->mpParentMenu ? mpMenuItem->mpParentMenu->getFrame() : NULL;
+    if( pFrame && AquaSalFrame::isAlive( pFrame ) && ! pFrame->GetWindow()->IsInModalMode() )
+    {
+        SalMenuEvent aMenuEvt;
+        aMenuEvt.mnId   = mpMenuItem->mnId;
+        aMenuEvt.mpMenu = mpMenuItem->mpVCLMenu;
+        pFrame->CallCallback(SALEVENT_MENUCOMMAND, &aMenuEvt);
+    }
+}
+@end
+
diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/inc/vcl/cmdevt.hxx ooo_SRC680_m233_src.aquavcl04/vcl/inc/vcl/cmdevt.hxx
--- ooo_SRC680_m233_src.orig/vcl/inc/vcl/cmdevt.hxx	2007-07-05 10:34:29.000000000 +0200
+++ ooo_SRC680_m233_src.aquavcl04/vcl/inc/vcl/cmdevt.hxx	2007-10-19 16:42:28.000000000 +0200
@@ -181,10 +181,8 @@
                         { return ((mnCode & KEY_MOD1) != 0); }
     BOOL            IsMod2() const
                         { return ((mnCode & KEY_MOD2) != 0); }
-#ifdef MACOSX
-    BOOL	    IsMod5() const
-			{ return ((mnCode & KEY_MOD5) != 0); }
-#endif
+    BOOL	        IsMod3() const
+                        { return ((mnCode & KEY_MOD3) != 0); }
 };
 
 inline CommandWheelData::CommandWheelData()
